Index: lemon/lgf_writer.h
===================================================================
--- lemon/lgf_writer.h	(revision 248)
+++ lemon/lgf_writer.h	(revision 319)
@@ -34,5 +34,4 @@
 #include <functional>
 
-#include <lemon/assert.h>
 #include <lemon/core.h>
 #include <lemon/maps.h>
@@ -56,5 +55,5 @@
     template <typename T>
     bool operator<(const T&, const T&) {
-      throw DataFormatError("Label map is not comparable");
+      throw FormatError("Label map is not comparable");
     }
 
@@ -204,5 +203,5 @@
           _map.find(str);
         if (it == _map.end()) {
-          throw DataFormatError("Item not found");
+          throw FormatError("Item not found");
         }
         return it->second;
@@ -224,5 +223,5 @@
           ::const_iterator it = _map.find(val);
         if (it == _map.end()) {
-          throw DataFormatError("Item not found");
+          throw FormatError("Item not found");
         }
         return (_graph.direction(val) ? '+' : '-') + it->second;
@@ -352,15 +351,36 @@
   class DigraphWriter;
 
+  /// \brief Return a \ref DigraphWriter class
+  ///
+  /// This function just returns a \ref DigraphWriter class.
+  /// \relates DigraphWriter
   template <typename Digraph>
-  DigraphWriter<Digraph> digraphWriter(std::ostream& os,
-                                       const Digraph& digraph);
-
+  DigraphWriter<Digraph> digraphWriter(const Digraph& digraph,
+                                       std::ostream& os = std::cout) {
+    DigraphWriter<Digraph> tmp(digraph, os);
+    return tmp;
+  }
+
+  /// \brief Return a \ref DigraphWriter class
+  ///
+  /// This function just returns a \ref DigraphWriter class.
+  /// \relates DigraphWriter
   template <typename Digraph>
-  DigraphWriter<Digraph> digraphWriter(const std::string& fn,
-                                       const Digraph& digraph);
-
+  DigraphWriter<Digraph> digraphWriter(const Digraph& digraph,
+                                       const std::string& fn) {
+    DigraphWriter<Digraph> tmp(digraph, fn);
+    return tmp;
+  }
+
+  /// \brief Return a \ref DigraphWriter class
+  ///
+  /// This function just returns a \ref DigraphWriter class.
+  /// \relates DigraphWriter
   template <typename Digraph>
-  DigraphWriter<Digraph> digraphWriter(const char *fn,
-                                       const Digraph& digraph);
+  DigraphWriter<Digraph> digraphWriter(const Digraph& digraph,
+                                       const char* fn) {
+    DigraphWriter<Digraph> tmp(digraph, fn);
+    return tmp;
+  }
 
   /// \ingroup lemon_io
@@ -383,5 +403,5 @@
   ///
   ///\code
-  /// DigraphWriter<Digraph>(std::cout, digraph).
+  /// DigraphWriter<Digraph>(digraph, std::cout).
   ///   nodeMap("coordinates", coord_map).
   ///   nodeMap("size", size).
@@ -453,6 +473,6 @@
     /// Construct a directed graph writer, which writes to the given
     /// output stream.
-    DigraphWriter(std::ostream& is, const Digraph& digraph)
-      : _os(&is), local_os(false), _digraph(digraph),
+    DigraphWriter(const Digraph& digraph, std::ostream& os = std::cout)
+      : _os(&os), local_os(false), _digraph(digraph),
         _skip_nodes(false), _skip_arcs(false) {}
 
@@ -461,7 +481,12 @@
     /// Construct a directed graph writer, which writes to the given
     /// output file.
-    DigraphWriter(const std::string& fn, const Digraph& digraph)
+    DigraphWriter(const Digraph& digraph, const std::string& fn)
       : _os(new std::ofstream(fn.c_str())), local_os(true), _digraph(digraph),
-        _skip_nodes(false), _skip_arcs(false) {}
+        _skip_nodes(false), _skip_arcs(false) {
+      if (!(*_os)) {
+        delete _os;
+        throw IoError("Cannot write file", fn);
+      }
+    }
 
     /// \brief Constructor
@@ -469,7 +494,12 @@
     /// Construct a directed graph writer, which writes to the given
     /// output file.
-    DigraphWriter(const char* fn, const Digraph& digraph)
+    DigraphWriter(const Digraph& digraph, const char* fn)
       : _os(new std::ofstream(fn)), local_os(true), _digraph(digraph),
-        _skip_nodes(false), _skip_arcs(false) {}
+        _skip_nodes(false), _skip_arcs(false) {
+      if (!(*_os)) {
+        delete _os;
+        throw IoError("Cannot write file", fn);
+      }
+    }
 
     /// \brief Destructor
@@ -497,10 +527,10 @@
   private:
 
-    friend DigraphWriter<Digraph> digraphWriter<>(std::ostream& os,
-                                                  const Digraph& digraph);
-    friend DigraphWriter<Digraph> digraphWriter<>(const std::string& fn,
-                                                  const Digraph& digraph);
-    friend DigraphWriter<Digraph> digraphWriter<>(const char *fn,
-                                                  const Digraph& digraph);
+    friend DigraphWriter<Digraph> digraphWriter<>(const Digraph& digraph,
+                                                  std::ostream& os);
+    friend DigraphWriter<Digraph> digraphWriter<>(const Digraph& digraph,
+                                                  const std::string& fn);
+    friend DigraphWriter<Digraph> digraphWriter<>(const Digraph& digraph,
+                                                  const char *fn);
 
     DigraphWriter(DigraphWriter& other)
@@ -904,48 +934,37 @@
   };
 
-  /// \brief Return a \ref DigraphWriter class
-  ///
-  /// This function just returns a \ref DigraphWriter class.
-  /// \relates DigraphWriter
-  template <typename Digraph>
-  DigraphWriter<Digraph> digraphWriter(std::ostream& os,
-                                       const Digraph& digraph) {
-    DigraphWriter<Digraph> tmp(os, digraph);
+  template <typename Graph>
+  class GraphWriter;
+
+  /// \brief Return a \ref GraphWriter class
+  ///
+  /// This function just returns a \ref GraphWriter class.
+  /// \relates GraphWriter
+  template <typename Graph>
+  GraphWriter<Graph> graphWriter(const Graph& graph,
+                                 std::ostream& os = std::cout) {
+    GraphWriter<Graph> tmp(graph, os);
     return tmp;
   }
 
-  /// \brief Return a \ref DigraphWriter class
-  ///
-  /// This function just returns a \ref DigraphWriter class.
-  /// \relates DigraphWriter
-  template <typename Digraph>
-  DigraphWriter<Digraph> digraphWriter(const std::string& fn,
-                                       const Digraph& digraph) {
-    DigraphWriter<Digraph> tmp(fn, digraph);
+  /// \brief Return a \ref GraphWriter class
+  ///
+  /// This function just returns a \ref GraphWriter class.
+  /// \relates GraphWriter
+  template <typename Graph>
+  GraphWriter<Graph> graphWriter(const Graph& graph, const std::string& fn) {
+    GraphWriter<Graph> tmp(graph, fn);
     return tmp;
   }
 
-  /// \brief Return a \ref DigraphWriter class
-  ///
-  /// This function just returns a \ref DigraphWriter class.
-  /// \relates DigraphWriter
-  template <typename Digraph>
-  DigraphWriter<Digraph> digraphWriter(const char* fn,
-                                       const Digraph& digraph) {
-    DigraphWriter<Digraph> tmp(fn, digraph);
+  /// \brief Return a \ref GraphWriter class
+  ///
+  /// This function just returns a \ref GraphWriter class.
+  /// \relates GraphWriter
+  template <typename Graph>
+  GraphWriter<Graph> graphWriter(const Graph& graph, const char* fn) {
+    GraphWriter<Graph> tmp(graph, fn);
     return tmp;
   }
-
-  template <typename Graph>
-  class GraphWriter;
-
-  template <typename Graph>
-  GraphWriter<Graph> graphWriter(std::ostream& os, const Graph& graph);
-
-  template <typename Graph>
-  GraphWriter<Graph> graphWriter(const std::string& fn, const Graph& graph);
-
-  template <typename Graph>
-  GraphWriter<Graph> graphWriter(const char *fn, const Graph& graph);
 
   /// \ingroup lemon_io
@@ -1009,6 +1028,6 @@
     /// Construct a directed graph writer, which writes to the given
     /// output stream.
-    GraphWriter(std::ostream& is, const Graph& graph)
-      : _os(&is), local_os(false), _graph(graph),
+    GraphWriter(const Graph& graph, std::ostream& os = std::cout)
+      : _os(&os), local_os(false), _graph(graph),
         _skip_nodes(false), _skip_edges(false) {}
 
@@ -1017,7 +1036,12 @@
     /// Construct a directed graph writer, which writes to the given
     /// output file.
-    GraphWriter(const std::string& fn, const Graph& graph)
+    GraphWriter(const Graph& graph, const std::string& fn)
       : _os(new std::ofstream(fn.c_str())), local_os(true), _graph(graph),
-        _skip_nodes(false), _skip_edges(false) {}
+        _skip_nodes(false), _skip_edges(false) {
+      if (!(*_os)) {
+        delete _os;
+        throw IoError("Cannot write file", fn);
+      }
+    }
 
     /// \brief Constructor
@@ -1025,7 +1049,12 @@
     /// Construct a directed graph writer, which writes to the given
     /// output file.
-    GraphWriter(const char* fn, const Graph& graph)
+    GraphWriter(const Graph& graph, const char* fn)
       : _os(new std::ofstream(fn)), local_os(true), _graph(graph),
-        _skip_nodes(false), _skip_edges(false) {}
+        _skip_nodes(false), _skip_edges(false) {
+      if (!(*_os)) {
+        delete _os;
+        throw IoError("Cannot write file", fn);
+      }
+    }
 
     /// \brief Destructor
@@ -1053,10 +1082,10 @@
   private:
 
-    friend GraphWriter<Graph> graphWriter<>(std::ostream& os,
-                                            const Graph& graph);
-    friend GraphWriter<Graph> graphWriter<>(const std::string& fn,
-                                            const Graph& graph);
-    friend GraphWriter<Graph> graphWriter<>(const char *fn,
-                                            const Graph& graph);
+    friend GraphWriter<Graph> graphWriter<>(const Graph& graph,
+                                            std::ostream& os);
+    friend GraphWriter<Graph> graphWriter<>(const Graph& graph,
+                                            const std::string& fn);
+    friend GraphWriter<Graph> graphWriter<>(const Graph& graph,
+                                            const char *fn);
 
     GraphWriter(GraphWriter& other)
@@ -1506,34 +1535,4 @@
   };
 
-  /// \brief Return a \ref GraphWriter class
-  ///
-  /// This function just returns a \ref GraphWriter class.
-  /// \relates GraphWriter
-  template <typename Graph>
-  GraphWriter<Graph> graphWriter(std::ostream& os, const Graph& graph) {
-    GraphWriter<Graph> tmp(os, graph);
-    return tmp;
-  }
-
-  /// \brief Return a \ref GraphWriter class
-  ///
-  /// This function just returns a \ref GraphWriter class.
-  /// \relates GraphWriter
-  template <typename Graph>
-  GraphWriter<Graph> graphWriter(const std::string& fn, const Graph& graph) {
-    GraphWriter<Graph> tmp(fn, graph);
-    return tmp;
-  }
-
-  /// \brief Return a \ref GraphWriter class
-  ///
-  /// This function just returns a \ref GraphWriter class.
-  /// \relates GraphWriter
-  template <typename Graph>
-  GraphWriter<Graph> graphWriter(const char* fn, const Graph& graph) {
-    GraphWriter<Graph> tmp(fn, graph);
-    return tmp;
-  }
-
   class SectionWriter;
 
@@ -1577,5 +1576,10 @@
     /// Construct a section writer, which writes into the given file.
     SectionWriter(const std::string& fn)
-      : _os(new std::ofstream(fn.c_str())), local_os(true) {}
+      : _os(new std::ofstream(fn.c_str())), local_os(true) {
+      if (!(*_os)) {
+        delete _os;
+        throw IoError("Cannot write file", fn);
+      }
+    }
 
     /// \brief Constructor
@@ -1583,5 +1587,10 @@
     /// Construct a section writer, which writes into the given file.
     SectionWriter(const char* fn)
-      : _os(new std::ofstream(fn)), local_os(true) {}
+      : _os(new std::ofstream(fn)), local_os(true) {
+      if (!(*_os)) {
+        delete _os;
+        throw IoError("Cannot write file", fn);
+      }
+    }
 
     /// \brief Destructor
Index: lemon/list_graph.h
===================================================================
--- lemon/list_graph.h	(revision 239)
+++ lemon/list_graph.h	(revision 341)
@@ -414,5 +414,5 @@
     ///
     ///\note The <tt>InArcIt</tt>s referencing the changed arc remain
-    ///valid. However the <tt>ArcIt<tt>s and <tt>OutArcIt</tt>s are
+    ///valid. However the <tt>ArcIt</tt>s and <tt>OutArcIt</tt>s are
     ///invalidated.
     ///
@@ -502,8 +502,6 @@
     ///be invalidated.
     ///
-    ///\warning This functionality cannot be used together with the
+    ///\warning This functionality cannot be used in conjunction with the
     ///Snapshot feature.
-    ///
-    ///\todo It could be implemented in a bit faster way.
     Node split(Node n, bool connect = true) {
       Node b = addNode();
@@ -843,6 +841,6 @@
 
     public:
-      operator Edge() const { 
-        return id != -1 ? edgeFromId(id / 2) : INVALID; 
+      operator Edge() const {
+        return id != -1 ? edgeFromId(id / 2) : INVALID;
       }
 
Index: lemon/maps.h
===================================================================
--- lemon/maps.h	(revision 220)
+++ lemon/maps.h	(revision 314)
@@ -44,5 +44,5 @@
   class MapBase {
   public:
-    /// \biref The key type of the map.
+    /// \brief The key type of the map.
     typedef K Key;
     /// \brief The value type of the map.
@@ -74,7 +74,7 @@
   };
 
-  /// Returns a \ref NullMap class
-
-  /// This function just returns a \ref NullMap class.
+  /// Returns a \c NullMap class
+
+  /// This function just returns a \c NullMap class.
   /// \relates NullMap
   template <typename K, typename V>
@@ -89,5 +89,5 @@
   /// value to each key.
   ///
-  /// In other aspects it is equivalent to \ref NullMap.
+  /// In other aspects it is equivalent to \c NullMap.
   /// So it conforms the \ref concepts::ReadWriteMap "ReadWriteMap"
   /// concept, but it absorbs the data written to it.
@@ -134,7 +134,7 @@
   };
 
-  /// Returns a \ref ConstMap class
-
-  /// This function just returns a \ref ConstMap class.
+  /// Returns a \c ConstMap class
+
+  /// This function just returns a \c ConstMap class.
   /// \relates ConstMap
   template<typename K, typename V>
@@ -157,5 +157,5 @@
   /// value to each key.
   ///
-  /// In other aspects it is equivalent to \ref NullMap.
+  /// In other aspects it is equivalent to \c NullMap.
   /// So it conforms the \ref concepts::ReadWriteMap "ReadWriteMap"
   /// concept, but it absorbs the data written to it.
@@ -183,7 +183,7 @@
   };
 
-  /// Returns a \ref ConstMap class with inlined constant value
-
-  /// This function just returns a \ref ConstMap class with inlined
+  /// Returns a \c ConstMap class with inlined constant value
+
+  /// This function just returns a \c ConstMap class with inlined
   /// constant value.
   /// \relates ConstMap
@@ -213,7 +213,7 @@
   };
 
-  /// Returns an \ref IdentityMap class
-
-  /// This function just returns an \ref IdentityMap class.
+  /// Returns an \c IdentityMap class
+
+  /// This function just returns an \c IdentityMap class.
   /// \relates IdentityMap
   template<typename T>
@@ -229,5 +229,5 @@
   /// values to integer keys from the range <tt>[0..size-1]</tt>.
   /// It can be used with some data structures, for example
-  /// \ref UnionFind, \ref BinHeap, when the used items are small
+  /// \c UnionFind, \c BinHeap, when the used items are small
   /// integers. This map conforms the \ref concepts::ReferenceMap
   /// "ReferenceMap" concept.
@@ -269,5 +269,5 @@
       : _vector(vector.begin(), vector.end()) {}
 
-    /// Constructs the map from another \ref RangeMap.
+    /// Constructs the map from another \c RangeMap.
     template <typename V1>
     RangeMap(const RangeMap<V1> &c)
@@ -312,7 +312,7 @@
   };
 
-  /// Returns a \ref RangeMap class
-
-  /// This function just returns a \ref RangeMap class.
+  /// Returns a \c RangeMap class
+
+  /// This function just returns a \c RangeMap class.
   /// \relates RangeMap
   template<typename V>
@@ -321,8 +321,8 @@
   }
 
-  /// \brief Returns a \ref RangeMap class created from an appropriate
+  /// \brief Returns a \c RangeMap class created from an appropriate
   /// \c std::vector
 
-  /// This function just returns a \ref RangeMap class created from an
+  /// This function just returns a \c RangeMap class created from an
   /// appropriate \c std::vector.
   /// \relates RangeMap
@@ -389,5 +389,5 @@
       : _map(map.begin(), map.end()), _value(value) {}
 
-    /// \brief Constructs the map from another \ref SparseMap.
+    /// \brief Constructs the map from another \c SparseMap.
     template<typename V1, typename Comp1>
     SparseMap(const SparseMap<Key, V1, Comp1> &c)
@@ -434,7 +434,7 @@
   };
 
-  /// Returns a \ref SparseMap class
-
-  /// This function just returns a \ref SparseMap class with specified
+  /// Returns a \c SparseMap class
+
+  /// This function just returns a \c SparseMap class with specified
   /// default value.
   /// \relates SparseMap
@@ -449,8 +449,8 @@
   }
 
-  /// \brief Returns a \ref SparseMap class created from an appropriate
+  /// \brief Returns a \c SparseMap class created from an appropriate
   /// \c std::map
 
-  /// This function just returns a \ref SparseMap class created from an
+  /// This function just returns a \c SparseMap class created from an
   /// appropriate \c std::map.
   /// \relates SparseMap
@@ -485,6 +485,4 @@
   ///
   /// \sa CombineMap
-  ///
-  /// \todo Check the requirements.
   template <typename M1, typename M2>
   class ComposeMap : public MapBase<typename M2::Key, typename M1::Value> {
@@ -504,7 +502,7 @@
   };
 
-  /// Returns a \ref ComposeMap class
-
-  /// This function just returns a \ref ComposeMap class.
+  /// Returns a \c ComposeMap class
+
+  /// This function just returns a \c ComposeMap class.
   ///
   /// If \c m1 and \c m2 are maps and the \c Value type of \c m2 is
@@ -541,6 +539,4 @@
   ///
   /// \sa ComposeMap
-  ///
-  /// \todo Check the requirements.
   template<typename M1, typename M2, typename F,
            typename V = typename F::result_type>
@@ -561,7 +557,7 @@
   };
 
-  /// Returns a \ref CombineMap class
-
-  /// This function just returns a \ref CombineMap class.
+  /// Returns a \c CombineMap class
+
+  /// This function just returns a \c CombineMap class.
   ///
   /// For example, if \c m1 and \c m2 are both maps with \c double
@@ -630,7 +626,7 @@
   };
 
-  /// Returns a \ref FunctorToMap class
-
-  /// This function just returns a \ref FunctorToMap class.
+  /// Returns a \c FunctorToMap class
+
+  /// This function just returns a \c FunctorToMap class.
   ///
   /// This function is specialized for adaptable binary function
@@ -689,7 +685,7 @@
   };
 
-  /// Returns a \ref MapToFunctor class
-
-  /// This function just returns a \ref MapToFunctor class.
+  /// Returns a \c MapToFunctor class
+
+  /// This function just returns a \c MapToFunctor class.
   /// \relates MapToFunctor
   template<typename M>
@@ -728,7 +724,7 @@
   };
 
-  /// Returns a \ref ConvertMap class
-
-  /// This function just returns a \ref ConvertMap class.
+  /// Returns a \c ConvertMap class
+
+  /// This function just returns a \c ConvertMap class.
   /// \relates ConvertMap
   template<typename V, typename M>
@@ -768,7 +764,7 @@
   };
 
-  /// Returns a \ref ForkMap class
-
-  /// This function just returns a \ref ForkMap class.
+  /// Returns a \c ForkMap class
+
+  /// This function just returns a \c ForkMap class.
   /// \relates ForkMap
   template <typename M1, typename M2>
@@ -812,7 +808,7 @@
   };
 
-  /// Returns an \ref AddMap class
-
-  /// This function just returns an \ref AddMap class.
+  /// Returns an \c AddMap class
+
+  /// This function just returns an \c AddMap class.
   ///
   /// For example, if \c m1 and \c m2 are both maps with \c double
@@ -860,7 +856,7 @@
   };
 
-  /// Returns a \ref SubMap class
-
-  /// This function just returns a \ref SubMap class.
+  /// Returns a \c SubMap class
+
+  /// This function just returns a \c SubMap class.
   ///
   /// For example, if \c m1 and \c m2 are both maps with \c double
@@ -909,7 +905,7 @@
   };
 
-  /// Returns a \ref MulMap class
-
-  /// This function just returns a \ref MulMap class.
+  /// Returns a \c MulMap class
+
+  /// This function just returns a \c MulMap class.
   ///
   /// For example, if \c m1 and \c m2 are both maps with \c double
@@ -957,7 +953,7 @@
   };
 
-  /// Returns a \ref DivMap class
-
-  /// This function just returns a \ref DivMap class.
+  /// Returns a \c DivMap class
+
+  /// This function just returns a \c DivMap class.
   ///
   /// For example, if \c m1 and \c m2 are both maps with \c double
@@ -1043,7 +1039,7 @@
   };
 
-  /// Returns a \ref ShiftMap class
-
-  /// This function just returns a \ref ShiftMap class.
+  /// Returns a \c ShiftMap class
+
+  /// This function just returns a \c ShiftMap class.
   ///
   /// For example, if \c m is a map with \c double values and \c v is
@@ -1057,7 +1053,7 @@
   }
 
-  /// Returns a \ref ShiftWriteMap class
-
-  /// This function just returns a \ref ShiftWriteMap class.
+  /// Returns a \c ShiftWriteMap class
+
+  /// This function just returns a \c ShiftWriteMap class.
   ///
   /// For example, if \c m is a map with \c double values and \c v is
@@ -1145,7 +1141,7 @@
   };
 
-  /// Returns a \ref ScaleMap class
-
-  /// This function just returns a \ref ScaleMap class.
+  /// Returns a \c ScaleMap class
+
+  /// This function just returns a \c ScaleMap class.
   ///
   /// For example, if \c m is a map with \c double values and \c v is
@@ -1159,7 +1155,7 @@
   }
 
-  /// Returns a \ref ScaleWriteMap class
-
-  /// This function just returns a \ref ScaleWriteMap class.
+  /// Returns a \c ScaleWriteMap class
+
+  /// This function just returns a \c ScaleWriteMap class.
   ///
   /// For example, if \c m is a map with \c double values and \c v is
@@ -1245,7 +1241,7 @@
   };
 
-  /// Returns a \ref NegMap class
-
-  /// This function just returns a \ref NegMap class.
+  /// Returns a \c NegMap class
+
+  /// This function just returns a \c NegMap class.
   ///
   /// For example, if \c m is a map with \c double values, then
@@ -1258,7 +1254,7 @@
   }
 
-  /// Returns a \ref NegWriteMap class
-
-  /// This function just returns a \ref NegWriteMap class.
+  /// Returns a \c NegWriteMap class
+
+  /// This function just returns a \c NegWriteMap class.
   ///
   /// For example, if \c m is a map with \c double values, then
@@ -1301,7 +1297,7 @@
   };
 
-  /// Returns an \ref AbsMap class
-
-  /// This function just returns an \ref AbsMap class.
+  /// Returns an \c AbsMap class
+
+  /// This function just returns an \c AbsMap class.
   ///
   /// For example, if \c m is a map with \c double values, then
@@ -1350,7 +1346,7 @@
   };
 
-  /// Returns a \ref TrueMap class
-
-  /// This function just returns a \ref TrueMap class.
+  /// Returns a \c TrueMap class
+
+  /// This function just returns a \c TrueMap class.
   /// \relates TrueMap
   template<typename K>
@@ -1387,7 +1383,7 @@
   };
 
-  /// Returns a \ref FalseMap class
-
-  /// This function just returns a \ref FalseMap class.
+  /// Returns a \c FalseMap class
+
+  /// This function just returns a \c FalseMap class.
   /// \relates FalseMap
   template<typename K>
@@ -1434,7 +1430,7 @@
   };
 
-  /// Returns an \ref AndMap class
-
-  /// This function just returns an \ref AndMap class.
+  /// Returns an \c AndMap class
+
+  /// This function just returns an \c AndMap class.
   ///
   /// For example, if \c m1 and \c m2 are both maps with \c bool values,
@@ -1482,7 +1478,7 @@
   };
 
-  /// Returns an \ref OrMap class
-
-  /// This function just returns an \ref OrMap class.
+  /// Returns an \c OrMap class
+
+  /// This function just returns an \c OrMap class.
   ///
   /// For example, if \c m1 and \c m2 are both maps with \c bool values,
@@ -1549,7 +1545,7 @@
   };
 
-  /// Returns a \ref NotMap class
-
-  /// This function just returns a \ref NotMap class.
+  /// Returns a \c NotMap class
+
+  /// This function just returns a \c NotMap class.
   ///
   /// For example, if \c m is a map with \c bool values, then
@@ -1562,7 +1558,7 @@
   }
 
-  /// Returns a \ref NotWriteMap class
-
-  /// This function just returns a \ref NotWriteMap class.
+  /// Returns a \c NotWriteMap class
+
+  /// This function just returns a \c NotWriteMap class.
   ///
   /// For example, if \c m is a map with \c bool values, then
@@ -1610,7 +1606,7 @@
   };
 
-  /// Returns an \ref EqualMap class
-
-  /// This function just returns an \ref EqualMap class.
+  /// Returns an \c EqualMap class
+
+  /// This function just returns an \c EqualMap class.
   ///
   /// For example, if \c m1 and \c m2 are maps with keys and values of
@@ -1658,7 +1654,7 @@
   };
 
-  /// Returns an \ref LessMap class
-
-  /// This function just returns an \ref LessMap class.
+  /// Returns an \c LessMap class
+
+  /// This function just returns an \c LessMap class.
   ///
   /// For example, if \c m1 and \c m2 are maps with keys and values of
@@ -1687,4 +1683,9 @@
 
   }
+
+  /// @}
+
+  /// \addtogroup maps
+  /// @{
 
   /// \brief Writable bool map for logging each \c true assigned element
@@ -1750,7 +1751,7 @@
   };
 
-  /// Returns a \ref LoggerBoolMap class
-
-  /// This function just returns a \ref LoggerBoolMap class.
+  /// Returns a \c LoggerBoolMap class
+
+  /// This function just returns a \c LoggerBoolMap class.
   ///
   /// The most important usage of it is storing certain nodes or arcs
@@ -1772,5 +1773,5 @@
   /// \note LoggerBoolMap is just \ref concepts::WriteMap "writable", so
   /// it cannot be used when a readable map is needed, for example as
-  /// \c ReachedMap for \ref Bfs, \ref Dfs and \ref Dijkstra algorithms.
+  /// \c ReachedMap for \c Bfs, \c Dfs and \c Dijkstra algorithms.
   ///
   /// \relates LoggerBoolMap
@@ -1779,4 +1780,9 @@
     return LoggerBoolMap<Iterator>(it);
   }
+
+  /// @}
+
+  /// \addtogroup graph_maps
+  /// @{
 
   /// Provides an immutable and unique id for each item in the graph.
@@ -1886,6 +1892,4 @@
     /// The value type of the InvertableMap.
     typedef typename Map::Value Value;
-
-
 
     /// \brief Constructor.
@@ -2054,6 +2058,4 @@
     }
 
-
-
   };
 
@@ -2271,5 +2273,5 @@
     ///
     /// Constructor
-    /// \param _digraph The digraph that the map belongs to.
+    /// \param digraph The digraph that the map belongs to.
     explicit SourceMap(const Digraph& digraph) : _digraph(digraph) {}
 
@@ -2287,7 +2289,7 @@
   };
 
-  /// \brief Returns a \ref SourceMap class.
-  ///
-  /// This function just returns an \ref SourceMap class.
+  /// \brief Returns a \c SourceMap class.
+  ///
+  /// This function just returns an \c SourceMap class.
   /// \relates SourceMap
   template <typename Digraph>
@@ -2310,5 +2312,5 @@
     ///
     /// Constructor
-    /// \param _digraph The digraph that the map belongs to.
+    /// \param digraph The digraph that the map belongs to.
     explicit TargetMap(const Digraph& digraph) : _digraph(digraph) {}
 
@@ -2326,7 +2328,7 @@
   };
 
-  /// \brief Returns a \ref TargetMap class.
-  ///
-  /// This function just returns a \ref TargetMap class.
+  /// \brief Returns a \c TargetMap class.
+  ///
+  /// This function just returns a \c TargetMap class.
   /// \relates TargetMap
   template <typename Digraph>
@@ -2349,5 +2351,5 @@
     ///
     /// Constructor
-    /// \param _graph The graph that the map belongs to.
+    /// \param graph The graph that the map belongs to.
     explicit ForwardMap(const Graph& graph) : _graph(graph) {}
 
@@ -2365,7 +2367,7 @@
   };
 
-  /// \brief Returns a \ref ForwardMap class.
-  ///
-  /// This function just returns an \ref ForwardMap class.
+  /// \brief Returns a \c ForwardMap class.
+  ///
+  /// This function just returns an \c ForwardMap class.
   /// \relates ForwardMap
   template <typename Graph>
@@ -2388,5 +2390,5 @@
     ///
     /// Constructor
-    /// \param _graph The graph that the map belongs to.
+    /// \param graph The graph that the map belongs to.
     explicit BackwardMap(const Graph& graph) : _graph(graph) {}
 
@@ -2404,7 +2406,7 @@
   };
 
-  /// \brief Returns a \ref BackwardMap class
-
-  /// This function just returns a \ref BackwardMap class.
+  /// \brief Returns a \c BackwardMap class
+
+  /// This function just returns a \c BackwardMap class.
   /// \relates BackwardMap
   template <typename Graph>
Index: lemon/path.h
===================================================================
--- lemon/path.h	(revision 236)
+++ lemon/path.h	(revision 313)
@@ -850,5 +850,5 @@
     int empty() const { return len == 0; }
 
-    /// \break Erase all arcs in the digraph.
+    /// \brief Erase all arcs in the digraph.
     void clear() {
       len = 0;
Index: lemon/random.h
===================================================================
--- lemon/random.h	(revision 209)
+++ lemon/random.h	(revision 280)
@@ -822,5 +822,4 @@
     /// \note The Cartesian form of the Box-Muller
     /// transformation is used to generate a random normal distribution.
-    /// \todo Consider using the "ziggurat" method instead.
     double gauss()
     {
Index: lemon/smart_graph.h
===================================================================
--- lemon/smart_graph.h	(revision 238)
+++ lemon/smart_graph.h	(revision 341)
@@ -301,5 +301,4 @@
     ///\warning This functionality cannot be used together with the Snapshot
     ///feature.
-    ///\todo It could be implemented in a bit faster way.
     Node split(Node n, bool connect = true)
     {
@@ -367,5 +366,5 @@
 
       ///This constructor immediately makes a snapshot of the digraph.
-      ///\param _g The digraph we make a snapshot of.
+      ///\param graph The digraph we make a snapshot of.
       Snapshot(SmartDigraph &graph) : _graph(&graph) {
         node_num=_graph->nodes.size();
@@ -379,5 +378,5 @@
       ///This function can be called more than once. In case of a repeated
       ///call, the previous snapshot gets lost.
-      ///\param _g The digraph we make the snapshot of.
+      ///\param graph The digraph we make the snapshot of.
       void save(SmartDigraph &graph)
       {
@@ -466,6 +465,6 @@
 
     public:
-      operator Edge() const { 
-        return _id != -1 ? edgeFromId(_id / 2) : INVALID; 
+      operator Edge() const {
+        return _id != -1 ? edgeFromId(_id / 2) : INVALID;
       }
 
@@ -777,5 +776,5 @@
 
       ///This constructor immediately makes a snapshot of the digraph.
-      ///\param g The digraph we make a snapshot of.
+      ///\param graph The digraph we make a snapshot of.
       Snapshot(SmartGraph &graph) {
         graph.saveSnapshot(*this);
@@ -788,5 +787,5 @@
       ///This function can be called more than once. In case of a repeated
       ///call, the previous snapshot gets lost.
-      ///\param g The digraph we make the snapshot of.
+      ///\param graph The digraph we make the snapshot of.
       void save(SmartGraph &graph)
       {
